<script setup lang="ts">
import { nextTick, provide, ref } from 'vue';
import { type Product } from '@/types/Product'
import { type ReceiptItem } from '@/types/ReceiptItem'

import ProductList from '@/components/ProductList.vue';
import ReceiptDetailTable from './ReceiptDetailTable.vue';
import ReceiptCard from './ReceiptCard.vue';
import MemberCard from './MemberCard.vue';
import ReceiptDialog from './ReceiptDialog.vue';

import { useReceiptStore } from '@/stores/receipt'

const dialog = ref(false)
provide('receiptDialog', dialog)

const receiptstore = useReceiptStore()
const tel = ref('')
const products1: Product[] = [
    {
        id: 1,
        name: 'ลาเต้ ร้อน',
        price: 35.00,
        type: 1
    },
    {
        id: 2,
        name: 'ลาเต้ เย็น',
        price: 40.00,
        type: 1
    },
    {
        id: 3,
        name: 'เอสเพรสโซ',
        price: 45.00,
        type: 1
    },
    {
        id: 4,
        name: 'อเมริกาโน',
        price: 45.00,
        type: 1
    },
    {
        id: 5,
        name: 'คาปูชิโน',
        price: 45.00,
        type: 1
    },
    {
        id: 6,
        name: 'มอคค่า เย็น',
        price: 35.00,
        type: 1
    },
    {
        id: 7,
        name: 'มอคค่า  ร้อน',
        price: 45.00,
        type: 1
    },
    {
        id: 8,
        name: 'แฟลต ไวท์',
        price: 45.00,
        type: 1
    },
    {
        id: 9,
        name: 'มัคคิอาโต',
        price: 45.00,
        type: 1
    }
]
const products2: Product[] = [{
    id: 10,
    name: 'ครัวซองต์',
    price: 35.00,
    type: 2
},
{
    id: 11,
    name: 'เค้กช็อคโก้',
    price: 45.00,
    type: 2
},
{
    id: 12,
    name: 'ขนมปังกระเทียม',
    price: 50.00,
    type: 2
},
{
    id: 13,
    name: 'ฮันนี่โทสต์',
    price: 55.00,
    type: 2
},
{
    id: 14,
    name: 'แพนเค้ก',
    price: 40.00,
    type: 2
},
{
    id: 15,
    name: 'มัฟฟิน',
    price: 30.00,
    type: 2
},
{
    id: 16,
    name: 'มาการอง',
    price: 100.00,
    type: 2
},
{
    id: 17,
    name: 'สโคน',
    price: 50.00,
    type: 2
},
{
    id: 18,
    name: 'โดนัท',
    price: 40.00,
    type: 2
},
]

const products3: Product[] = [{
    id: 19,
    name: 'ชาเขียว',
    price: 40.00,
    type: 3
},
{
    id: 20,
    name: 'ชามะนาว',
    price: 40.00,
    type: 3
},
{
    id: 21,
    name: 'ชาเย็น',
    price: 45.00,
    type: 3
},
{
    id: 22,
    name: 'ชานม',
    price: 50.00,
    type: 3
}, {
    id: 23,
    name: 'ชาสตอเบอรี่',
    price: 45.00,
    type: 3
},
{
    id: 24,
    name: 'ชาแอปเปิ้ล',
    price: 50.00,
    type: 3
},
]
const tab = ref(1)
const selected = (p: Product) => {
    console.log('ProductView: ' + p)
    receiptstore.addReceiptItem(p)
    nextTick(() => {
        if (divReceiptItems.value) divReceiptItems.value.scrollTo(0, divReceiptItems.value.scrollHeight)
    })
}
const showReceipt = function () {
    console.log(receiptstore.receipt.receivedAmount)
    if (receiptstore.receipt.total == 0) {
        alert('กรุณาเพิ่มสินค้าในรายการ!!')
    } else if (receiptstore.receipt.cash < receiptstore.receipt.total) {
        alert('จำนวนเงินไม่เพียงพอ!!')
    } else {
        receiptstore.showReceiptDialog()
    }
}
const clearall = function () {
    receiptstore.clear();
    tel.value = '';
};
const divReceiptItems = ref<HTMLElement | null>(null)
</script>   
<template>
    <v-sheet style="background-color: rgb(84, 65, 8);">
    
    <v-container >
        
        <v-row>
            <v-col cols="12" md="6" style="background-color: rgb(139, 123, 102);">
                <v-sheet min-width="300" max-width="600" height="640" elevation="6"
                    style="background-color: rgb(105, 82, 63);">
                    <v-tabs v-model="tab" color="white" align-tabs="center">
                        <v-tab :value="1" color="white">Coffee</v-tab>
                        <v-tab :value="2" color="white">Dessert</v-tab>
                        <v-tab :value="3" color="white">Tea</v-tab>
                    </v-tabs>
                    <v-window v-model="tab">
                        <v-window-item :value="1">
                            <ProductList :products="products1" @selectedProduct="selected"
                                style="background-color: rgb(252, 244, 218);"></ProductList>
                        </v-window-item>
                        <v-window-item :value="2">
                            <ProductList :products="products2" @selectedProduct="selected"
                                style="background-color: rgb(252, 244, 218);"></ProductList>
                        </v-window-item>
                        <v-window-item :value="3">
                            <ProductList :products="products3" @selectedProduct="selected"
                                style="background-color: rgb(252, 244, 218);"></ProductList>
                        </v-window-item>
                    </v-window>
                </v-sheet></v-col>
            <v-col cols="12" md="6" style="background-color: rgb(139, 123, 102);">
                <v-container style="padding: 0;">
                    <v-row>
                        <v-col cols="12">
                            <div ref='divReceiptItems' style="height: 300; overflow: auto;">
                                <v-sheet min-width="300" max-width="600" height="250" elevation="6"
                                    style="background-color: rgb(252, 244, 218);">
                                    <ReceiptDetailTable></ReceiptDetailTable>
                                </v-sheet>
                            </div>
                        </v-col>
                        <v-col cols="12">
                            <v-sheet min-width="300" max-width="600" height="150" elevation="6"
                                style="background-color: rgb(252, 244, 218);">
                                <MemberCard></MemberCard>
                            </v-sheet>
                        </v-col>
                        <v-col cols="12">
                            <v-sheet min-width="300" max-width="600" height="120" elevation="6"
                                style="background-color: rgb(252, 244, 218);">
                                <ReceiptCard></ReceiptCard>
                            </v-sheet>
                        </v-col>
                        <v-col cols="12">
                        <v-sheet min-width="300" max-width="600" height="100" elevation="6"
                            style="background-color: rgb(252, 244, 218);">
                            <v-container>
                                <v-row>
                                    <v-col cols="12">
                                        <v-text-field v-model="receiptstore.receipt.cash" label="จำนวนเงิน"
                                            outlined></v-text-field>
                                    </v-col>
                                </v-row>
                            </v-container>
                        </v-sheet>
                    </v-col>
                        <v-col cols="12">
                            <v-sheet min-width="300" max-width="600" height="100" elevation="6"
                                style="background-color: rgb(252, 244, 218);">
                                <v-container>
                                    <v-row>
                                        <v-col cols="12" sm="6"><v-btn block rounded="x1" color="red" size="large" @click="() => {
                                            receiptstore.dialog = false;

                                            receiptstore.clear();
                                        }">
                                                ยกเลิก
                                            </v-btn></v-col>

                                        <v-col cols="12" sm="6"><v-btn block rounded="x1" color="primary" size="large"
                                                @click="showReceipt">ชำระเงิน</v-btn></v-col>
                                    </v-row>
                                </v-container>
                            </v-sheet>
                        </v-col>
                    </v-row>
                </v-container></v-col>

        </v-row>
    </v-container>
    <ReceiptDialog></ReceiptDialog>
</v-sheet>
</template>